local fluid = nil
local fluid_name = nil
local st = nil
local item = nil
local rname = nil
local tech = nil
local i = 1
local recipe = nil

for _, recipe in pairs(data.raw.recipe) do
  --log("recipe name: "..recipe.name)
  fluid_name = string.match(recipe.name, "^fill%-(.+)%-storage%-tank$")
  if fluid_name then
    --log("Found fill recipe with fluid: "..fluid_name)
    if not data.raw.fluid[fluid_name] then
      data.raw.item[fluid_name.."-storage-tank"] = nil
      rname = "fill-"..fluid_name.."-storage-tank"
      data.raw.recipe[rname] = nil
      tech = data.raw.technology["fluid-handling"]
      --log("fluid-handling: " ..serpent.block(tech))
      if tech and tech.effects and #tech.effects > 0 then
        for i=1,#tech.effects do
          if (tech.effects[i][1] and tech.effects[i][1] == "unlock-recipe" and tech.effects[i][2] == rname)
            or (tech.effects[i].type and tech.effects[i].type == "unlock-recipe" and tech.effects[i].recipe == rname)
          then
            table.remove(tech.effects, i)
            break
          end
        end

        rname = "empty-"..fluid_name.."-storage-tank"
        data.raw.recipe[rname] = nil
        for i=1,#tech.effects do
          if (tech.effects[i][1] and tech.effects[i][1] == "unlock-recipe" and tech.effects[i][2] == rname)
            or (tech.effects[i].type and tech.effects[i].type == "unlock-recipe" and tech.effects[i].recipe == rname)
          then
            table.remove(tech.effects, i)
            break
          end
        end
      end
    end
  end
end