
require "control.placement"


local function on_init(event)
  local force = nil
  local tech = game.technology_prototypes["fluid-handling"]
  local rname = nil
  local recipe = nil

  if tech then
    for _, force in pairs(game.forces) do
      if force.technologies["fluid-handling"].researched == true then
        for r_name, recipe in pairs(force.recipes) do
          if string.match(r_name, "^fill%-.+%-storage%-tank$") or string.match(r_name, "^empty%-.+%-storage%-tank$") then
            recipe.enabled = true
          end
        end
      end
    end
  end
end

script.on_init(on_init)
script.on_configuration_changed(on_init)